## atlas-ecmwf 0.36.0

=== CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

############################################################################################
# Atlas

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

################################################################################
# Initialise project Atlas

project( atlas LANGUAGES CXX )

set( ATLAS_BITS_GLOBAL 64 CACHE STRING "bits used to define a global index (atlas::gidx_t)" )
set( ATLAS_BITS_LOCAL  32 CACHE STRING "bits used to define a local index (atlas::idx_t)" )

################################################################################
# Required packages

if( ATLAS_BITS_LOCAL MATCHES 64 )
  ecbuild_find_package( NAME eckit VERSION 1.17.1 REQUIRED )
else()
  ecbuild_find_package( NAME eckit VERSION 1.16 REQUIRED )
endif()

ecbuild_debug( "   eckit_FEATURES : [${eckit_FEATURES}]" )

add_subdirectory(atlas_io)
find_package(atlas_io)

################################################################################
# Features that can be enabled / disabled with -DENABLE_<FEATURE>

ecbuild_add_option( FEATURE ATLAS_GRID
                    DESCRIPTION "Build grid related features" )

ecbuild_add_option( FEATURE ATLAS_FIELD
                    DESCRIPTION "Build field and memory management related features" )

ecbuild_add_option( FEATURE ATLAS_FUNCTIONSPACE
                    DESCRIPTION "Build functionspace related features (mesh, functionspace, parallel)"
                    CONDITION atlas_HAVE_ATLAS_GRID AND atlas_HAVE_ATLAS_FIELD )

ecbuild_add_option( FEATURE ATLAS_INTERPOLATION
                    DESCRIPTION "Build interpolation related features"
                    CONDITION atlas_HAVE_ATLAS_FUNCTIONSPACE )

ecbuild_add_option( FEATURE ATLAS_TRANS
                    DESCRIPTION "Build transform related features"
                    CONDITION atlas_HAVE_ATLAS_FUNCTIONSPACE )

ecbuild_add_option( FEATURE ATLAS_NUMERICS
                    DESCRIPTION "Build numerics related features"
                    CONDITION atlas_HAVE_ATLAS_FUNCTIONSPACE )

ecbuild_add_option( FEATURE ECKIT_DEVELOP
                    DESCRIPTION "Used to enable new features or API depending on eckit develop branch, not yet in a tagged release"
                    DEFAULT OFF )


include( features/BOUNDSCHECKING )
include( features/FORTRAN )
include( features/MPI )
include( features/OMP )
include( features/FFTW )
include( features/ECTRANS )
include( features/TESSELATION )
include( features/GRIDTOOLS_STORAGE )
include( features/ACC )
include( features/EIGEN )
include( features/PROJ )
include( features/SANDBOX )
include( features/CLANG_TIDY )
include( features/INCLUDE_WHAT_YOU_USE )
include( features/INIT_SNAN )
include( features/DOCS )
include( features/ATLAS_RUN )

################################################################################
# sources

include( atlas_compile_flags )

add_subdirectory( src )
add_subdirectory( doc )

################################################################################
# Export and summarize

include( atlas_export )

ecbuild_print_summary()

=== atlas_io/CMakeLists.txt ===
# (C) Copyright 2021 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

############################################################################################
# Atlas-IO

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

################################################################################
# Initialise project Atlas

project( atlas_io VERSION ${atlas_VERSION} LANGUAGES CXX )

################################################################################
# Required packages

ecbuild_find_package( NAME eckit REQUIRED )

ecbuild_debug( "   eckit_FEATURES : [${eckit_FEATURES}]" )

################################################################################
# Features that can be enabled / disabled with -DENABLE_<FEATURE>

################################################################################
# sources

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

check_cxx_source_compiles( "#include <cxxabi.h>\n int main() { char * type; int status; char * r = abi::__cxa_demangle(type, 0, 0, &status); }"
    ATLAS_IO_HAVE_CXXABI_H )

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
  set( ATLAS_IO_BIG_ENDIAN    1 )
  set( ATLAS_IO_LITTLE_ENDIAN 0 )
else()
  set( ATLAS_IO_BIG_ENDIAN    0 )
  set( ATLAS_IO_LITTLE_ENDIAN 1 )
endif()


add_subdirectory( src )
add_subdirectory( tests )

################################################################################
# Export and summarize

ecbuild_add_resources(
    TARGET atlas_io-others
    SOURCES_PACK
        README.md
        CHANGELOG.md
        LICENSE
)

ecbuild_install_project( NAME Atlas-IO )
ecbuild_print_summary()

=== src/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

if( atlas_HAVE_OMP_CXX )
  set( atlas_HAVE_OMP_CXX 1 )
else()
  set( atlas_HAVE_OMP_CXX 0 )
endif()

if( atlas_HAVE_OMP_Fortran )
  set( atlas_HAVE_OMP_Fortran 1 )
else()
  set( atlas_HAVE_OMP_Fortran 0 )
endif()

if( atlas_HAVE_TESSELATION )
  set( atlas_HAVE_TESSELATION 1 )
else()
  set( atlas_HAVE_TESSELATION 0 )
endif()

if( atlas_HAVE_QHULL )
  set( atlas_HAVE_QHULL 1 )
else()
  set( atlas_HAVE_QHULL 0 )
endif()

if( atlas_HAVE_CGAL )
  set( atlas_HAVE_CGAL 1 )
else()
  set( atlas_HAVE_CGAL 0 )
endif()

if( atlas_HAVE_PROJ )
  set( atlas_HAVE_PROJ 1 )
else()
  set( atlas_HAVE_PROJ 0 )
endif()

if( atlas_HAVE_FORTRAN )
  set( atlas_HAVE_FORTRAN 1 )
else()
  set( atlas_HAVE_FORTRAN 0 )
endif()

if( atlas_HAVE_ECTRANS )
  set( atlas_HAVE_ECTRANS 1 )
else()
  set( atlas_HAVE_ECTRANS 0 )
endif()

if( atlas_HAVE_PACKAGE_ECTRANS )
  set( atlas_HAVE_PACKAGE_ECTRANS 1 )
else()
  set( atlas_HAVE_PACKAGE_ECTRANS 0 )
endif()

if( atlas_HAVE_FFTW )
  set( atlas_HAVE_FFTW 1 )
else()
  set( atlas_HAVE_FFTW 0 )
endif()

if( atlas_HAVE_BOUNDSCHECKING )
  set( atlas_HAVE_BOUNDSCHECKING 1 )
else()
  set( atlas_HAVE_BOUNDSCHECKING 0 )
endif()

if( atlas_HAVE_INIT_SNAN )
  set( atlas_HAVE_INIT_SNAN 1 )
else()
  set( atlas_HAVE_INIT_SNAN 0 )
endif()

if( atlas_HAVE_GRIDTOOLS_STORAGE )
  set( atlas_HAVE_GRIDTOOLS_STORAGE 1 )
else()
  set( atlas_HAVE_GRIDTOOLS_STORAGE 0 )
endif()

set( atlas_BUILD_TYPE_RELEASE 0 )
set( atlas_BUILD_TYPE_DEBUG   0 )
if( CMAKE_BUILD_TYPE MATCHES "Release" )
  set( atlas_BUILD_TYPE_RELEASE 1 )
endif()
if( CMAKE_BUILD_TYPE MATCHES "Debug" )
  set( atlas_BUILD_TYPE_DEBUG 1 )
endif()

if( atlas_HAVE_ECKIT_DEVELOP )
  set( ATLAS_ECKIT_DEVELOP 1 )
else()
  set( ATLAS_ECKIT_DEVELOP 0 )
endif()

ecbuild_parse_version( ${eckit_VERSION} PREFIX ATLAS_ECKIT )
math( EXPR ATLAS_ECKIT_VERSION_INT "( 10000 * ${ATLAS_ECKIT_VERSION_MAJOR} ) + ( 100 * ${ATLAS_ECKIT_VERSION_MINOR} ) + ${ATLAS_ECKIT_VERSION_PATCH}" )

add_subdirectory( atlas_acc_support )

add_subdirectory( atlas )

if( atlas_HAVE_FORTRAN )
 add_subdirectory( atlas_f )
endif()

add_subdirectory( apps )
add_subdirectory( tests )

if( HAVE_SANDBOX )
    add_subdirectory( sandbox )
endif()

=== src/atlas/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

### config headers

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/atlas )

configure_file( library/defines.h.in   library/defines.h   )
configure_file( library/version.h.in   library/version.h   )
configure_file( library/git_sha1.h.in  library/git_sha1.h  )

install( FILES
  ${CMAKE_CURRENT_BINARY_DIR}/library/defines.h
  ${CMAKE_CURRENT_BINARY_DIR}/library/version.h
  ${CMAKE_CURRENT_BINARY_DIR}/library/git_sha1.h
  DESTINATION
  ${INSTALL_INCLUDE_DIR}/atlas/library
)

### sources

list( APPEND atlas_srcs
${CMAKE_CURRENT_BINARY_DIR}/library/git_sha1.h
${CMAKE_CURRENT_BINARY_DIR}/library/defines.h
library.h
library/config.h
library/FloatingPointExceptions.h
library/FloatingPointExceptions.cc
library/Library.h
library/Library.cc
library/Plugin.h
library/Plugin.cc
runtime/AtlasTool.h
runtime/AtlasTool.cc
runtime/Log.h
runtime/Log.cc
runtime/Trace.h
runtime/trace/CallStack.h
runtime/trace/CallStack.cc
runtime/trace/CodeLocation.cc
runtime/trace/CodeLocation.h
runtime/trace/TraceT.h
runtime/trace/Nesting.cc
runtime/trace/Nesting.h
runtime/trace/Barriers.cc
runtime/trace/Barriers.h
runtime/trace/Logging.cc
runtime/trace/Logging.h
runtime/trace/Timings.h
runtime/trace/Timings.cc
runtime/Exception.cc
runtime/Exception.h

library/detail/BlackMagic.h
library/detail/Debug.h


parallel/mpi/mpi.cc
parallel/mpi/mpi.h
parallel/omp/omp.cc
parallel/omp/omp.h
parallel/omp/copy.h
parallel/omp/fill.h
parallel/omp/sort.h

util/Config.cc
util/Config.h

)

list( APPEND atlas_grid_srcs

option.h
option/Options.h
option/Options.cc
option/TransOptions.h
option/TransOptions.cc


projection.h
projection/Projection.cc
projection/Projection.h
projection/Jacobian.h
projection/detail/CubedSphereEquiAnglProjection.cc
projection/detail/CubedSphereEquiAnglProjection.h
projection/detail/CubedSphereEquiDistProjection.cc
projection/detail/CubedSphereEquiDistProjection.h
projection/detail/CubedSphereProjectionBase.cc
projection/detail/CubedSphereProjectionBase.h
projection/detail/LambertAzimuthalEqualAreaProjection.cc
projection/detail/LambertAzimuthalEqualAreaProjection.h
projection/detail/LambertConformalConicProjection.cc
projection/detail/LambertConformalConicProjection.h
projection/detail/LonLatProjection.cc
projection/detail/LonLatProjection.h
projection/detail/MercatorProjection.cc
projection/detail/MercatorProjection.h
projection/detail/ProjectionFactory.cc
projection/detail/ProjectionFactory.h
projection/detail/ProjectionImpl.cc
projection/detail/ProjectionImpl.h
projection/detail/ProjectionUtilities.h
projection/detail/SchmidtProjection.cc
projection/detail/SchmidtProjection.h
projection/detail/VariableResolutionProjection.cc
projection/detail/VariableResolutionProjection.h

domain.h
domain/Domain.cc
domain/Domain.h
domain/detail/Domain.cc
domain/detail/Domain.h
domain/detail/RectangularDomain.h
domain/detail/RectangularDomain.cc
domain/detail/EmptyDomain.h
domain/detail/EmptyDomain.cc
domain/detail/GlobalDomain.h
domain/detail/GlobalDomain.cc
domain/detail/ZonalBandDomain.h
domain/detail/ZonalBandDomain.cc
domain/detail/DomainFactory.h
domain/detail/DomainFactory.cc

grid.h
grid/CubedSphereGrid.cc
grid/CubedSphereGrid.h
grid/Grid.cc
grid/Grid.h
grid/SpecRegistry.cc
grid/SpecRegistry.h
grid/StructuredGrid.cc
grid/StructuredGrid.h
grid/UnstructuredGrid.cc
grid/UnstructuredGrid.h

util/GaussianLatitudes.cc
util/GaussianLatitudes.h

grid/Spacing.cc
grid/Spacing.h
grid/Iterator.h
grid/Iterator.cc
grid/Stencil.h
grid/StencilComputer.h
grid/StencilComputer.cc
grid/Tiles.h
grid/Tiles.cc

grid/detail/grid/CubedSphere.cc
grid/detail/grid/CubedSphere.h
grid/detail/grid/GridBuilder.h
grid/detail/grid/GridBuilder.cc
grid/detail/grid/GridFactory.h
grid/detail/grid/GridFactory.cc
grid/detail/grid/Grid.h
grid/detail/grid/Grid.cc
grid/detail/grid/Structured.cc
grid/detail/grid/Structured.h
grid/detail/grid/Unstructured.cc
grid/detail/grid/Unstructured.h
grid/detail/grid/Gaussian.h
grid/detail/grid/Gaussian.cc
grid/detail/grid/LonLat.h
grid/detail/grid/LonLat.cc
grid/detail/grid/Regional.h
grid/detail/grid/Regional.cc
grid/detail/grid/RegionalVariableResolution.h
grid/detail/grid/RegionalVariableResolution.cc
grid/detail/grid/Healpix.h
grid/detail/grid/Healpix.cc

grid/detail/tiles/Tiles.cc
grid/detail/tiles/Tiles.h
grid/detail/tiles/TilesFactory.h
grid/detail/tiles/TilesFactory.cc
grid/detail/tiles/FV3Tiles.cc
grid/detail/tiles/FV3Tiles.h
grid/detail/tiles/LFRicTiles.cc
grid/detail/tiles/LFRicTiles.h


grid/detail/spacing/Spacing.cc
grid/detail/spacing/Spacing.h
grid/detail/spacing/SpacingFactory.cc
grid/detail/spacing/SpacingFactory.h
grid/detail/spacing/CustomSpacing.h
grid/detail/spacing/CustomSpacing.cc
grid/detail/spacing/LinearSpacing.h
grid/detail/spacing/LinearSpacing.cc
grid/detail/spacing/FocusSpacing.h
grid/detail/spacing/FocusSpacing.cc
grid/detail/spacing/GaussianSpacing.h
grid/detail/spacing/GaussianSpacing.cc
grid/detail/spacing/gaussian/Latitudes.cc
grid/detail/spacing/gaussian/Latitudes.h
grid/detail/spacing/gaussian/N.cc
grid/detail/spacing/gaussian/N.h
grid/detail/spacing/gaussian/N16.cc    # TL31
grid/detail/spacing/gaussian/N24.cc    # TL47
grid/detail/spacing/gaussian/N32.cc    # TL63
grid/detail/spacing/gaussian/N48.cc    # TL95
grid/detail/spacing/gaussian/N64.cc    # TL127
grid/detail/spacing/gaussian/N80.cc    # TL159
grid/detail/spacing/gaussian/N96.cc    # TL191
grid/detail/spacing/gaussian/N128.cc   # TL255
grid/detail/spacing/gaussian/N160.cc   # TL319
grid/detail/spacing/gaussian/N200.cc   # TL399
grid/detail/spacing/gaussian/N256.cc   # TL511
grid/detail/spacing/gaussian/N320.cc   # TL639
grid/detail/spacing/gaussian/N400.cc   # TL799
grid/detail/spacing/gaussian/N512.cc   # TL1023
grid/detail/spacing/gaussian/N576.cc   # TL1151
grid/detail/spacing/gaussian/N640.cc   # TL1279
grid/detail/spacing/gaussian/N800.cc   # TL1599
grid/detail/spacing/gaussian/N1024.cc  # TL2047
grid/detail/spacing/gaussian/N1280.cc  # TL2559
grid/detail/spacing/gaussian/N1600.cc  # TL3199
grid/detail/spacing/gaussian/N2000.cc  # TL3999
grid/detail/spacing/gaussian/N4000.cc  # TL7999
grid/detail/spacing/gaussian/N8000.cc  # TL15999

grid/detail/pl/classic_gaussian/N.h
grid/detail/pl/classic_gaussian/N.cc
grid/detail/pl/classic_gaussian/PointsPerLatitude.h
grid/detail/pl/classic_gaussian/PointsPerLatitude.cc
grid/detail/pl/classic_gaussian/N16.cc    # TL31
grid/detail/pl/classic_gaussian/N24.cc    # TL47
grid/detail/pl/classic_gaussian/N32.cc    # TL63
grid/detail/pl/classic_gaussian/N48.cc    # TL95
grid/detail/pl/classic_gaussian/N64.cc    # TL127
grid/detail/pl/classic_gaussian/N80.cc    # TL159
grid/detail/pl/classic_gaussian/N96.cc    # TL191
grid/detail/pl/classic_gaussian/N128.cc   # TL255
grid/detail/pl/classic_gaussian/N160.cc   # TL319
grid/detail/pl/classic_gaussian/N200.cc   # TL399
grid/detail/pl/classic_gaussian/N256.cc   # TL511
grid/detail/pl/classic_gaussian/N320.cc   # TL639
grid/detail/pl/classic_gaussian/N400.cc   # TL799
grid/detail/pl/classic_gaussian/N512.cc   # TL1023
grid/detail/pl/classic_gaussian/N576.cc   # TL1151
grid/detail/pl/classic_gaussian/N640.cc   # TL1279
grid/detail/pl/classic_gaussian/N800.cc   # TL1599
grid/detail/pl/classic_gaussian/N1024.cc  # TL2047
grid/detail/pl/classic_gaussian/N1280.cc  # TL2559
grid/detail/pl/classic_gaussian/N1600.cc  # TL3199
grid/detail/pl/classic_gaussian/N2000.cc  # TL3999
grid/detail/pl/classic_gaussian/N4000.cc  # TL7999
grid/detail/pl/classic_gaussian/N8000.cc  # TL15999

grid/Vertical.h
grid/Vertical.cc

)

list( APPEND atlas_grid_partitioning_srcs

grid/StructuredPartitionPolygon.h
grid/StructuredPartitionPolygon.cc


grid/Distribution.cc
grid/Distribution.h
grid/Partitioner.h
grid/Partitioner.cc

grid/detail/distribution/DistributionImpl.h
grid/detail/distribution/DistributionImpl.cc
grid/detail/distribution/DistributionArray.cc
grid/detail/distribution/DistributionArray.h
grid/detail/distribution/DistributionFunction.cc
grid/detail/distribution/DistributionFunction.h

grid/detail/distribution/BandsDistribution.cc
grid/detail/distribution/BandsDistribution.h
grid/detail/distribution/SerialDistribution.cc
grid/detail/distribution/SerialDistribution.h

grid/detail/partitioner/BandsPartitioner.cc
grid/detail/partitioner/BandsPartitioner.h
grid/detail/partitioner/CheckerboardPartitioner.cc
grid/detail/partitioner/CheckerboardPartitioner.h
grid/detail/partitioner/CubedSpherePartitioner.cc
grid/detail/partitioner/CubedSpherePartitioner.h
grid/detail/partitioner/EqualBandsPartitioner.cc
grid/detail/partitioner/EqualBandsPartitioner.h
grid/detail/partitioner/EqualAreaPartitioner.cc
grid/detail/partitioner/EqualAreaPartitioner.h
grid/detail/partitioner/EqualRegionsPartitioner.cc
grid/detail/partitioner/EqualRegionsPartitioner.h
grid/detail/partitioner/MatchingMeshPartitioner.h
grid/detail/partitioner/MatchingMeshPartitioner.cc
grid/detail/partitioner/MatchingMeshPartitionerBruteForce.cc
grid/detail/partitioner/MatchingMeshPartitionerBruteForce.h
grid/detail/partitioner/MatchingMeshPartitionerCubedSphere.cc
grid/detail/partitioner/MatchingMeshPartitionerCubedSphere.h
grid/detail/partitioner/MatchingMeshPartitionerLonLatPolygon.cc
grid/detail/partitioner/MatchingMeshPartitionerLonLatPolygon.h
grid/detail/partitioner/MatchingMeshPartitionerSphericalPolygon.cc
grid/detail/partitioner/MatchingMeshPartitionerSphericalPolygon.h
grid/detail/partitioner/MatchingFunctionSpacePartitioner.h
grid/detail/partitioner/MatchingFunctionSpacePartitioner.cc
grid/detail/partitioner/MatchingFunctionSpacePartitionerLonLatPolygon.cc
grid/detail/partitioner/MatchingFunctionSpacePartitionerLonLatPolygon.h
grid/detail/partitioner/Partitioner.cc
grid/detail/partitioner/Partitioner.h
grid/detail/partitioner/RegularBandsPartitioner.cc
grid/detail/partitioner/RegularBandsPartitioner.h
grid/detail/partitioner/SerialPartitioner.cc
grid/detail/partitioner/SerialPartitioner.h
)

if( atlas_HAVE_ECTRANS )
list( APPEND atlas_grid_partitioning_srcs
  grid/detail/partitioner/TransPartitioner.h
  grid/detail/partitioner/TransPartitioner.cc
)
endif()
if( atlas_HAVE_PROJ )
list( APPEND atlas_grid_srcs
  projection/detail/ProjProjection.cc
  projection/detail/ProjProjection.h
)
endif()


# Append CGAL_COMPLE_FLAGS only to this file ( see ATLAS-193 )
if( CGAL_COMPILE_FLAGS )
  set_source_files_properties( mesh/actions/BuildConvexHull3D.cc
                               PROPERTIES COMPILE_FLAGS "${CGAL_COMPILE_FLAGS}" )
endif()

list( APPEND atlas_mesh_srcs
grid/detail/vertical/VerticalInterface.h     # Uses Field
grid/detail/vertical/VerticalInterface.cc    # Uses Field

mesh.h
mesh/Connectivity.cc
mesh/Connectivity.h
mesh/ElementType.cc
mesh/ElementType.h
mesh/elementtypes/Classification.h
mesh/elementtypes/Triangle.h
mesh/elementtypes/Quadrilateral.h
mesh/elementtypes/Pentagon.h
mesh/Elements.cc
mesh/Elements.h
mesh/Halo.cc
mesh/Halo.h
mesh/HybridElements.cc
mesh/HybridElements.h
mesh/Mesh.cc
mesh/Mesh.h
mesh/MeshBuilder.cc
mesh/MeshBuilder.h
mesh/Nodes.cc
mesh/Nodes.h
mesh/IsGhostNode.h
mesh/PartitionPolygon.cc
mesh/PartitionPolygon.h
mesh/detail/MeshImpl.cc
mesh/detail/MeshImpl.h
mesh/detail/MeshIntf.cc
mesh/detail/MeshIntf.h
mesh/detail/MeshBuilderIntf.cc
mesh/detail/MeshBuilderIntf.h
mesh/detail/PartitionGraph.cc
mesh/detail/PartitionGraph.h
mesh/detail/AccumulateFacets.h
mesh/detail/AccumulateFacets.cc

util/Unique.h
util/Unique.cc

mesh/actions/ExtendNodesGlobal.h
mesh/actions/ExtendNodesGlobal.cc
mesh/actions/BuildDualMesh.h
mesh/actions/BuildCellCentres.cc
mesh/actions/BuildCellCentres.h
mesh/actions/Build2DCellCentres.cc
mesh/actions/Build2DCellCentres.h

=== src/atlas_f/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/../atlas/atlas_f.h @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.fypp ${CMAKE_CURRENT_BINARY_DIR}/../atlas/atlas_f.fypp)

install( FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.fypp
  ${CMAKE_CURRENT_BINARY_DIR}/../atlas/atlas_f.h
  DESTINATION
  ${INSTALL_INCLUDE_DIR}/atlas )


### fortran bindings

function(generate_fortran_bindings output filename)

  set( options "" )
  set( single_value_args OUTPUT MODULE )
  set( multi_value_args "" )
  cmake_parse_arguments( _PAR "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )

  get_filename_component(base ${filename} NAME_WE)
  set(base_abs ${CMAKE_CURRENT_SOURCE_DIR}/${base})
  set(outfile ${CMAKE_CURRENT_BINARY_DIR}/${base}_c_binding.f90)

  if( _PAR_OUTPUT )
    set(outfile ${_PAR_OUTPUT})
  endif()
  set(${output} ${${output}} ${outfile} PARENT_SCOPE)

  if( NOT _PAR_MODULE )
    set( _PAR_MODULE "atlas_${base}_c_binding" )
  endif()

  set( FINT32 "integer(c_int)"  )
  set( FINT64 "integer(c_long)" )
  set( F_GIDX ${FINT${ATLAS_BITS_GLOBAL}} )
  set( F_IDX ${FINT${ATLAS_BITS_LOCAL}} )

  add_custom_command(
    OUTPUT ${outfile}
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/tools/c2f.py ${CMAKE_CURRENT_SOURCE_DIR}/${filename}
            -o ${outfile} -m ${_PAR_MODULE}
            -t '{"idx_t":"${F_IDX}","gidx_t":"${F_GIDX}"}'
    DEPENDS ${filename} )
  set_source_files_properties(${outfile} PROPERTIES GENERATED TRUE)
endfunction()

generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/Grid.h
    MODULE    atlas_grid_Grid_c_binding
    OUTPUT    grid_Grid_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/CubedSphere.h
    MODULE    atlas_grid_CubedSphere_c_binding
    OUTPUT    grid_CubedSphere_c_binding.f90 )    
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/Structured.h
    MODULE    atlas_grid_Structured_c_binding
    OUTPUT    grid_Structured_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/Unstructured.h
    MODULE    atlas_grid_Unstructured_c_binding
    OUTPUT    grid_Unstructured_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/distribution/DistributionImpl.h
    MODULE atlas_distribution_c_binding
    OUTPUT distribution_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/vertical/VerticalInterface.h
    MODULE atlas_vertical_c_binding
    OUTPUT vertical_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/Partitioner.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/projection/detail/ProjectionImpl.h
    MODULE atlas_projection_c_binding
    OUTPUT projection_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/domain/detail/Domain.h
    MODULE atlas_domain_c_binding
    OUTPUT domain_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/detail/MeshIntf.h
    MODULE    atlas_mesh_c_binding
    OUTPUT    atlas_mesh_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/detail/MeshBuilderIntf.h
    MODULE    atlas_meshbuilder_c_binding
    OUTPUT    atlas_meshbuilder_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/Nodes.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/Connectivity.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/HybridElements.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/Elements.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/ElementType.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildParallelFields.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildPeriodicBoundaries.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildHalo.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildEdges.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildDualMesh.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/WriteLoadBalanceReport.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/meshgenerator/detail/MeshGeneratorInterface.h
    MODULE atlas_meshgenerator_c_binding
    OUTPUT meshgenerator_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/output/Output.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/output/detail/GmshInterface.h
  MODULE    atlas_output_gmsh_c_binding
  OUTPUT    output_Gmsh_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/State.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/detail/FieldInterface.h
    MODULE    atlas_field_c_binding
    OUTPUT    field_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/FieldSet.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/FunctionSpaceInterface.h
    MODULE atlas_functionspace_c_binding
    OUTPUT functionspace_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/SpectralInterface.h
    MODULE    atlas_functionspace_Spectral_c_binding
    OUTPUT    functionspace_Spectral_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/StructuredColumnsInterface.h
    MODULE    atlas_functionspace_StructuredColumns_c_binding
    OUTPUT    functionspace_StructuredColumns_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/BlockStructuredColumnsInterface.h
    MODULE    atlas_functionspace_BlockStructuredColumns_c_binding
    OUTPUT    functionspace_BlockStructuredColumns_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/CellColumnsInterface.h
    MODULE    atlas_functionspace_CellColumns_c_binding
    OUTPUT    functionspace_CellColumns_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/NodeColumnsInterface.h
    MODULE    atlas_functionspace_NodeColumns_c_binding
    OUTPUT    functionspace_NodeColumns_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/EdgeColumns.h
    MODULE    atlas_functionspace_EdgeColumns_c_binding
    OUTPUT    functionspace_EdgeColumns_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/PointCloudInterface.h
    MODULE    atlas_functionspace_PointCloud_c_binding
    OUTPUT    functionspace_PointCloud_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/redistribution/detail/RedistributionInterface.h
    MODULE    atlas_redistribution_c_binding
    OUTPUT    redistribution_c_binding.f90)

if( atlas_HAVE_ATLAS_NUMERICS )
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/Nabla.h)
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/Nabla.h)
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/Method.h )
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/fvm/Method.h
        MODULE    atlas_fvm_method_c_binding
        OUTPUT    fvm_method_c_binding.f90 )
endif()

if( atlas_HAVE_ATLAS_INTERPOLATION )
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/interpolation/Interpolation.h
        MODULE    atlas_interpolation_c_binding
        OUTPUT    interpolation_c_binding.f90 )
endif()

if( atlas_HAVE_ATLAS_TRANS )
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/trans/detail/TransInterface.h
        MODULE    atlas_trans_c_binding
        OUTPUT    trans_c_binding.f90 )
endif()

generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Allocate.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Metadata.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Config.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Geometry.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/KDTree.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/output/detail/GmshIO.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/parallel/HaloExchange.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/parallel/GatherScatter.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/parallel/Checksum.h)
generate_fortran_bindings(FORTRAN_BINDINGS internals/atlas_read_file.h)
generate_fortran_bindings(FORTRAN_BINDINGS internals/Library.h)
generate_fortran_bindings(FORTRAN_BINDINGS runtime/atlas_trace.h MODULE atlas_trace_c_binding OUTPUT atlas_trace_c_binding.f90 )


list( APPEND atlas_trans_srcs 
    trans/atlas_Trans_module.F90
)

list( APPEND atlas_interpolation_srcs 
    interpolation/atlas_Interpolation_module.F90
)

list( APPEND atlas_numerics_srcs 
    numerics/atlas_Method_module.F90
    numerics/atlas_fvm_module.F90
    numerics/atlas_Nabla_module.F90
)

if( NOT atlas_HAVE_ATLAS_TRANS )
    unset( atlas_trans_srcs )
endif()

if( NOT atlas_HAVE_ATLAS_INTERPOLATION )
    unset( atlas_interpolation_srcs )
endif()

if( NOT atlas_HAVE_ATLAS_NUMERICS )
    unset( atlas_numerics_srcs )
endif()


### atlas fortran lib
ecbuild_add_library( TARGET atlas_f
    AUTO_VERSION
    SOURCES
        ${FORTRAN_BINDINGS}
        atlas_module.F90
        util/atlas_functions_module.F90
        util/atlas_kinds_module.F90
        util/atlas_JSON_module.F90
        util/atlas_Config_module.F90
        util/atlas_Geometry_module.F90
        util/atlas_KDTree_module.F90
        util/atlas_Metadata_module.F90
        util/atlas_allocate_module.F90
        output/atlas_output_module.F90
        domain/atlas_Domain_module.F90
        functionspace/atlas_FunctionSpace_module.F90
        functionspace/atlas_functionspace_EdgeColumns_module.F90
        functionspace/atlas_functionspace_CellColumns_module.F90
        functionspace/atlas_functionspace_NodeColumns_module.fypp
        functionspace/atlas_functionspace_StructuredColumns_module.F90
        functionspace/atlas_functionspace_BlockStructuredColumns_module.F90
        functionspace/atlas_functionspace_Spectral_module.F90
        functionspace/atlas_functionspace_PointCloud_module.F90
        field/atlas_FieldSet_module.fypp
        field/atlas_State_module.F90
        field/atlas_Field_module.fypp
        grid/atlas_Grid_module.F90
        grid/atlas_GridDistribution_module.F90
        grid/atlas_Vertical_module.F90
        grid/atlas_Partitioner_module.F90
        mesh/atlas_MeshBuilder_module.F90
        mesh/atlas_MeshGenerator_module.F90
        mesh/atlas_Mesh_module.F90
        mesh/atlas_mesh_Nodes_module.F90
        mesh/atlas_mesh_Edges_module.F90
        mesh/atlas_mesh_Cells_module.F90
        mesh/atlas_Connectivity_module.F90
        mesh/atlas_HybridElements_module.F90
        mesh/atlas_Elements_module.F90
        mesh/atlas_ElementType_module.F90
        mesh/atlas_mesh_actions_module.F90
        parallel/atlas_GatherScatter_module.fypp
        parallel/atlas_Checksum_module.fypp
        parallel/atlas_HaloExchange_module.fypp
        projection/atlas_Projection_module.F90
        redistribution/atlas_Redistribution_module.F90
        internals/atlas_read_file.h
        internals/atlas_read_file.cc
        internals/Library.h
        internals/Library.cc
        runtime/atlas_trace.cc
        runtime/atlas_Trace_module.F90
        ${atlas_trans_srcs}
        ${atlas_interpolation_srcs}
        ${atlas_numerics_srcs}

  PUBLIC_LIBS
        $<LINK_ONLY:atlas>
        fckit

  PRIVATE_LIBS
        $<${atlas_HAVE_OMP_Fortran}:OpenMP::OpenMP_Fortran>

  PUBLIC_INCLUDES

=== src/tests/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

if( NOT DEFINED MPI_SLOTS )
  set( MPI_SLOTS 9999 )
endif()

######################################################
# Compiler bugs force us to disable some tests

if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI"  AND
    CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 16.8 )
  set( atlas_fctest_parametrisation_DISABLED TRUE )
  ecbuild_warn( "PGI Fortran compiler version tested up to 16.7 has a compiler bug "
                "that leads to a segfaults for atlas_fctest_parametrisation. "
                "Disabling this test..." )
endif()

if( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
  ## ATLAS-170 workaround internal compiler error

      ## Other workaround that makes ecbuild_remove_fortran_flags work when variables are empty
      string( TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_CAPS )
      if( NOT CMAKE_Fortran_FLAGS )
          set( CMAKE_Fortran_FLAGS " " )
      endif()
      if( NOT CMAKE_Fortran_FLAGS_${CMAKE_BUILD_TYPE_CAPS} )
          set( CMAKE_Fortran_FLAGS_${CMAKE_BUILD_TYPE_CAPS} " " )
      endif()

  ecbuild_remove_fortran_flags( "-g" )
endif()

######################################################

# Macro atlas_add_cuda_test
# Envisioned to become part of ecbuild_add_test with a CUDA option
# in a future ecbuild release
macro( atlas_add_cuda_test )
  set( options           "" )
  set( single_value_args TARGET )
  set( multi_value_args  SOURCES LIBS ENVIRONMENT )
  cmake_parse_arguments( _PAR "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )

  if(_PAR_UNPARSED_ARGUMENTS)
    ecbuild_critical("Unknown keywords given to atlas_add_cuda_test(): \"${_PAR_UNPARSED_ARGUMENTS}\"")
  endif()

  if( HAVE_CUDA AND HAVE_TESTS )

    ecbuild_debug("atlas_add_cuda_test: Adding test ${_PAR_TARGET}")

    list( APPEND _PAR_ENVIRONMENT "ATLAS_RUN_NGPUS=1" )
    list( REMOVE_DUPLICATES _PAR_ENVIRONMENT )

    list( APPEND _libs ${_PAR_LIBS} )
    if( _libs )
      ecbuild_debug("atlas_add_cuda_test: Test ${_PAR_TARGET} explicitly links with libraries ${_libs}")
    endif()

    if( atlas_CUDA_LANGUAGE_ENABLED )

      ecbuild_add_test( TARGET      ${_PAR_TARGET}
                        SOURCES     ${_PAR_SOURCES}
                        LIBS        ${_libs}
                        ENVIRONMENT ${_PAR_ENVIRONMENT} )

    else()

      cuda_add_executable (${_PAR_TARGET} ${_PAR_SOURCES})

      if( _libs )
        target_link_libraries(${_PAR_TARGET} ${_libs})
      endif()

      # whatever project settings are, we always build tests with the build_rpath, not the install_rpath
      set_property( TARGET ${_PAR_TARGET} PROPERTY BUILD_WITH_INSTALL_RPATH FALSE )
      set_property( TARGET ${_PAR_TARGET} PROPERTY SKIP_BUILD_RPATH         FALSE )

      if( CMAKE_CROSSCOMPILING_EMULATOR )
        add_test ( NAME ${_PAR_TARGET} COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} ${_PAR_TARGET} )
      else()
        add_test ( NAME ${_PAR_TARGET} COMMAND ${_PAR_TARGET} )
      endif()

      set_property( TEST ${_PAR_TARGET} APPEND PROPERTY ENVIRONMENT "${_PAR_ENVIRONMENT}" )

    endif()
  endif()
endmacro()

if( ECKIT_INCLUDE_DIRS ) # eckit not yet ported to CMake3
  include_directories( ${ECKIT_INCLUDE_DIRS} )
endif()

if( NOT DEFINED transi_VERSION )
  if( TRANSI_VERSION VERSION_LESS 0.6 )# transi not yet ported to CMake3
    include_directories( ${TRANSI_INCLUDE_DIRS} )
  endif()
endif()

if( HAVE_CUDA )
  set( ATLAS_TEST_ENVIRONMENT "ATLAS_RUN_NGPUS=1" )
endif()

add_subdirectory( util )
add_subdirectory( runtime )

if (atlas_HAVE_ATLAS_GRID)
  add_subdirectory( projection )
  add_subdirectory( grid )
endif()

if (atlas_HAVE_ATLAS_FIELD)
  add_subdirectory( acc )
  add_subdirectory( array )
  add_subdirectory( field )
endif()

if (atlas_HAVE_ATLAS_FUNCTIONSPACE)
  add_subdirectory( parallel )
  add_subdirectory( mesh )
  add_subdirectory( functionspace )
  add_subdirectory( io )
  add_subdirectory( output )
  add_subdirectory( redistribution )
endif()

if (atlas_HAVE_ATLAS_TRANS)
  add_subdirectory( trans )
endif()

if (atlas_HAVE_ATLAS_INTERPOLATION)
  add_subdirectory( interpolation )
  add_subdirectory( linalg )
endif()

if (atlas_HAVE_ATLAS_NUMERICS)
  add_subdirectory( numerics )
endif()

add_subdirectory( acceptance_tests )
add_subdirectory( export_tests )

=== atlas_io/src/atlas_io/CMakeLists.txt ===
configure_file( detail/defines.h.in   detail/defines.h   )
install( FILES
  ${CMAKE_CURRENT_BINARY_DIR}/detail/defines.h
  DESTINATION
  ${INSTALL_INCLUDE_DIR}/atlas_io/detail
)

ecbuild_add_library( TARGET atlas_io

    INSTALL_HEADERS    ALL
    HEADER_DESTINATION include/atlas_io
    PUBLIC_LIBS        eckit
    PUBLIC_INCLUDES
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
      $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>

    SOURCES
        atlas-io.h
        Data.cc
        Data.h
        detail/Assert.h
        detail/Base64.cc
        detail/Base64.h
        detail/Checksum.h
        detail/Checksum.cc
        detail/DataInfo.h
        detail/DataType.cc
        detail/DataType.h
        detail/Decoder.cc
        detail/Decoder.h
        detail/Defaults.h
        detail/Encoder.cc
        detail/Encoder.h
        detail/Endian.h
        detail/Link.cc
        detail/Link.h
        detail/ParsedRecord.h
        detail/RecordInfo.h
        detail/RecordSections.h
        detail/Reference.h
        detail/sfinae.h
        detail/StaticAssert.h
        detail/tag.h
        detail/Time.cc
        detail/Time.h
        detail/Type.h
        detail/TypeTraits.h
        detail/Version.h
        Exceptions.cc
        Exceptions.h
        FileStream.cc
        FileStream.h
        Metadata.cc
        Metadata.h
        print/TableFormat.cc
        print/TableFormat.h
        print/JSONFormat.cc
        print/JSONFormat.h
        print/Bytes.cc
        print/Bytes.h
        ReadRequest.cc
        ReadRequest.h
        Record.cc
        Record.h
        RecordItem.cc
        RecordItem.h
        RecordItemReader.cc
        RecordItemReader.h
        RecordPrinter.cc
        RecordPrinter.h
        RecordReader.cc
        RecordReader.h
        RecordWriter.cc
        RecordWriter.h
        Session.cc
        Session.h
        Stream.cc
        Stream.h
        Trace.cc
        Trace.h
        types/array.h
        types/array/ArrayMetadata.cc
        types/array/ArrayMetadata.h
        types/array/ArrayReference.cc
        types/array/ArrayReference.h
        types/array/adaptors/StdArrayAdaptor.h
        types/array/adaptors/StdVectorAdaptor.h
        types/array/adaptors/StdVectorOfStdArrayAdaptor.h
        types/string.h
        types/scalar.h
        types/scalar.cc
        ${CMAKE_CURRENT_BINARY_DIR}/detail/defines.h
)

target_compile_features( atlas_io PUBLIC cxx_std_17 )

=== src/tests/array/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.


ecbuild_add_test( TARGET atlas_test_array_slicer
  SOURCES  test_array_slicer.cc
  LIBS     atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_array_foreach
  SOURCES  test_array_foreach.cc
  LIBS     atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_array
  SOURCES  test_array.cc
  LIBS     atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

#ecbuild_add_test( TARGET atlas_test_table
#  SOURCES  test_table.cc
#  LIBS     atlas
#  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
#)

ecbuild_add_test( TARGET atlas_test_array_vector
  SOURCES  test_array_vector.cc
  LIBS     atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  CONDITION atlas_HAVE_GRIDTOOLS_STORAGE
)

ecbuild_add_test( TARGET atlas_test_svector
  SOURCES  test_svector.cc
  LIBS     atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}

)

ecbuild_add_test( TARGET atlas_test_array_view_util
  SOURCES  test_array_view_util.cc
  LIBS     atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_array_indexview
  SOURCES  test_indexview.cc
  LIBS     atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

if( CMAKE_BUILD_TYPE MATCHES "DEBUG" )
  set ( CMAKE_NVCC_FLAGS "-G" )
endif()

atlas_add_cuda_test(
  TARGET atlas_test_array_kernel
  SOURCES test_array_kernel.cu
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)
atlas_add_cuda_test(
  TARGET atlas_test_vector_kernel
  SOURCES test_vector_kernel.cu
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

atlas_add_cuda_test(
  TARGET atlas_test_svector_kernel
  SOURCES test_svector_kernel.cu
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

=== src/tests/field/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

ecbuild_add_test( TARGET atlas_test_fieldset
    SOURCES test_fieldset.cc
    LIBS atlas
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_field_missingvalue
    SOURCES     test_field_missingvalue.cc
    LIBS        atlas
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_field_foreach
  SOURCES  test_field_foreach.cc
  LIBS     atlas
  OMP      4
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

if( HAVE_FCTEST )

  add_fctest( TARGET atlas_fctest_field
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field.F90
    LIBS            atlas_f
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
  )
  
  add_fctest( TARGET atlas_fctest_field_wrap
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field_wrap.F90
    LIBS            atlas_f
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
  )

  add_fctest( TARGET atlas_fctest_field_view
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field_view.F90
    LIBS            atlas_f OpenMP::OpenMP_Fortran
    OMP             3
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
    CONDITION       atlas_HAVE_OMP_Fortran
  )

  add_fctest( TARGET atlas_fctest_field_host
    CONDITION       atlas_HAVE_GRIDTOOLS_STORAGE AND ATLAS_GRIDTOOLS_STORAGE_BACKEND_HOST
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field_host.F90
    LIBS            atlas_f
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT}
  )

  add_fctest( TARGET atlas_fctest_field_device
    CONDITION       atlas_HAVE_GRIDTOOLS_STORAGE AND ATLAS_GRIDTOOLS_STORAGE_BACKEND_CUDA AND atlas_HAVE_ACC
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_field_gpu.F90 external_acc_routine.F90
    LIBS            atlas_f
    ENVIRONMENT     ${ATLAS_TEST_ENVIRONMENT} ATLAS_RUN_NGPUS=1
  )

  if( TARGET atlas_fctest_field_device )
    target_compile_options( atlas_fctest_field_device PUBLIC ${ACC_Fortran_FLAGS} )
    target_link_libraries( atlas_fctest_field_device ${ACC_Fortran_FLAGS} )
  endif()

endif()

=== src/tests/interpolation/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

ecbuild_add_test( TARGET atlas_test_Quad3D
  CONDITION eckit_EIGEN_FOUND
  SOURCES   test_Quad3D.cc
  LIBS      atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_Quad2D
  SOURCES   test_Quad2D.cc
  LIBS      atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_Triag2D
  SOURCES   test_Triag2D.cc
  LIBS      atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

if( atlas_HAVE_ATLAS_INTERPOLATION )

ecbuild_add_test( TARGET atlas_test_interpolation_conservative
  SOURCES   test_interpolation_conservative.cc
  LIBS      atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_finite_element
  SOURCES   test_interpolation_finite_element.cc
  LIBS      atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_unstructured_bilinear_lonlat
  SOURCES   test_interpolation_unstructured_bilinear_lonlat.cc
  LIBS      atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_finite_element_cached
  SOURCES   test_interpolation_finite_element_cached.cc
  LIBS      atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_grid_box_average
  SOURCES   test_interpolation_grid_box_average.cc
  LIBS      atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_k_nearest_neighbours
  SOURCES   test_interpolation_k_nearest_neighbours.cc
  LIBS      atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_cubic_prototype
  SOURCES  test_interpolation_cubic_prototype.cc CubicInterpolationPrototype.h
  LIBS     atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_executable( TARGET atlas_test_interpolation_structured2D
  SOURCES  test_interpolation_structured2D.cc
  LIBS     atlas
  NOINSTALL
)

ecbuild_add_test( TARGET atlas_test_interpolation_non_linear
  SOURCES  test_interpolation_non_linear.cc
  LIBS     atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_bilinear
  COMMAND atlas_test_interpolation_structured2D ARGS --scheme linear
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_bicubic
  COMMAND atlas_test_interpolation_structured2D ARGS --scheme cubic
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_biquasicubic
  COMMAND atlas_test_interpolation_structured2D ARGS --scheme quasicubic
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_interpolation_structured2D_to_unstructured
  SOURCES  test_interpolation_structured2D_to_unstructured.cc
  LIBS     atlas
  MPI      2
  CONDITION eckit_HAVE_MPI
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)


ecbuild_add_test( TARGET atlas_test_interpolation_structured2D_to_points
  SOURCES  test_interpolation_structured2D_to_points.cc
  LIBS     atlas
  MPI      4
  CONDITION eckit_HAVE_MPI
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)


ecbuild_add_test( TARGET atlas_test_interpolation_cubedsphere
  SOURCES  test_interpolation_cubedsphere.cc
  LIBS     atlas
  MPI      6
  CONDITION eckit_HAVE_MPI AND MPI_SLOTS GREATER_EQUAL 6
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

endif()

=== src/tests/mesh/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

if( HAVE_FCTEST )

  add_fctest( TARGET atlas_fctest_mesh
    LINKER_LANGUAGE Fortran
    CONDITION       NOT atlas_fctest_mesh_DISABLED
    SOURCES         fctest_mesh.F90
    LIBS            atlas_f
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  )

  add_fctest( TARGET atlas_fctest_meshgen
    LINKER_LANGUAGE Fortran
    CONDITION       ON
    SOURCES         fctest_meshgen.F90
    LIBS            atlas_f
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  )

  add_fctest( TARGET atlas_fctest_mesh_triangular_mesh_builder
    LINKER_LANGUAGE Fortran
    CONDITION       ON
    SOURCES         fctest_mesh_triangular_mesh_builder.F90
    LIBS            atlas_f
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  )

  add_fctest( TARGET atlas_fctest_connectivity
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_connectivity.F90
    LIBS            atlas_f
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  )

  add_fctest( TARGET atlas_fctest_elements
    LINKER_LANGUAGE Fortran
    SOURCES         fctest_elements.F90
    LIBS            atlas_f
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  )

endif()

ecbuild_add_test( TARGET atlas_test_parfields
  MPI        2
  CONDITION  eckit_HAVE_MPI
  SOURCES    test_parfields.cc
  LIBS       atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_halo
  MPI        5
  CONDITION  eckit_HAVE_MPI AND MPI_SLOTS GREATER_EQUAL 5
  SOURCES    test_halo.cc ../TestMeshes.h
  LIBS       atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_distmesh
  MPI        5
  CONDITION  eckit_HAVE_MPI AND MPI_SLOTS GREATER_EQUAL 5
  SOURCES    test_distmesh.cc ../TestMeshes.h
  LIBS       atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test(
  TARGET      atlas_test_cgal_mesh_gen_from_points
  SOURCES     test_cgal_mesh_gen_from_points.cc
  CONDITION   atlas_HAVE_TESSELATION
  LIBS        atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test(
  TARGET atlas_test_mesh_build_edges
  SOURCES test_mesh_build_edges.cc
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_mesh_node2cell
  MPI        4
  CONDITION  eckit_HAVE_MPI
  SOURCES    test_mesh_node2cell.cc
  LIBS       atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_meshgen_splitcomm
  MPI         4
  CONDITION   eckit_HAVE_MPI
  SOURCES     test_meshgen_splitcomm.cc
  LIBS        atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

foreach( test connectivity stream_connectivity elements ll meshgen3d rgg )
  ecbuild_add_test( TARGET atlas_test_${test}
    SOURCES test_${test}.cc
    LIBS atlas
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  )
endforeach()

ecbuild_add_test( TARGET atlas_test_healpixmeshgen
  SOURCES test_healpixmeshgen.cc
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_cubedsphere_meshgen
  MPI        8
  CONDITION  eckit_HAVE_MPI AND MPI_SLOTS GREATER_EQUAL 8 AND atlas_HAVE_ATLAS_INTERPOLATION
  SOURCES test_cubedsphere_meshgen.cc
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

if( TEST atlas_test_cubedsphere_meshgen )
    set_tests_properties( atlas_test_cubedsphere_meshgen PROPERTIES TIMEOUT 30 )
endif()

ecbuild_add_test( TARGET atlas_test_mesh_builder
  SOURCES test_mesh_builder.cc
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_mesh_builder_parallel
  MPI        6
  CONDITION  eckit_HAVE_MPI AND MPI_SLOTS GREATER_EQUAL 6
  SOURCES test_mesh_builder_parallel.cc
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_mesh_triangular_mesh_builder
  SOURCES test_mesh_triangular_mesh_builder.cc
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_executable( TARGET atlas_test_mesh_reorder
  SOURCES  test_mesh_reorder.cc
  LIBS     atlas
  NOINSTALL
)

ecbuild_add_test( TARGET atlas_test_mesh_reorder_O16
  COMMAND atlas_test_mesh_reorder ARGS --grid O16
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_mesh_reorder_unstructured
  COMMAND atlas_test_mesh_reorder ARGS --mesh ${CMAKE_CURRENT_SOURCE_DIR}/test_mesh_reorder_unstructured.msh --grid "unstructured"
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

foreach( test footprint )
  ecbuild_add_test( TARGET atlas_test_${test}
    SOURCES test_${test}.cc
    LIBS atlas
    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  )
endforeach()



atlas_add_cuda_test(
  TARGET atlas_test_connectivity_kernel
  SOURCES test_connectivity_kernel.cu
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_pentagon_element
  SOURCES test_pentagon_element.cc
  LIBS atlas
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
  CONDITION atlas_HAVE_ATLAS_INTERPOLATION
)

=== src/tests/redistribution/CMakeLists.txt ===
#
# (C) Crown Copyright 2021 Met Office
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#

if( atlas_HAVE_ATLAS_FUNCTIONSPACE )

if( HAVE_FORTRAN )
  add_fctest( TARGET atlas_fctest_redistribution
    MPI 4
    CONDITION        eckit_HAVE_MPI
    LINKER_LANGUAGE  Fortran
    SOURCES          fctest_redistribution.F90
    LIBS             atlas_f
    ENVIRONMENT      ${ATLAS_TEST_ENVIRONMENT}
  )
endif()

ecbuild_add_test( TARGET atlas_test_redistribution_structured
  SOURCES   test_redistribution_structured.cc
  MPI       8
  LIBS      atlas
  CONDITION eckit_HAVE_MPI AND MPI_SLOTS GREATER_EQUAL 8
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

ecbuild_add_test( TARGET atlas_test_redistribution_generic
  SOURCES   test_redistribution_generic.cc
  MPI       8
  LIBS      atlas
  CONDITION eckit_HAVE_MPI AND MPI_SLOTS GREATER_EQUAL 8
  ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
)

endif()

=== debian/changelog ===
atlas-ecmwf (0.36.0-2) unstable; urgency=medium

  * Build-dep on architecture-is-64-bit
  * Move to Arch: any rather than hand-coded list of  64-bit archs
  * Drop obsolete breaks/replaces in d/control
  * Use dh-fortran-mod (>= 0.31) to revert fmoddir to libdir  root
  * Include fortran-support.mk
	
 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 31 Dec 2023 18:47:35 +0000

atlas-ecmwf (0.36.0-1) unstable; urgency=medium

  * New upstream release
  * Enable tesselation; build-dep on libqhull-dev
  * Update lib soname to 0.36
  * Drop merged g++13.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Dec 2023 07:53:48 +0000

atlas-ecmwf (0.35.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 25 Oct 2023 06:42:17 +0100

atlas-ecmwf (0.35.0-1) unstable; urgency=medium

  * New upstream release
    - rebase patches
  * Update lib soname to 0.35

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 05 Oct 2023 13:10:03 +0100

=== debian/control ===
Source: atlas-ecmwf
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-buildinfo, 
  dh-fortran-mod (>= 0.31),
  ecbuild (>= 3.3.2),
  clang-tidy,
  chrpath,
  libfftw3-dev,
  libproj-dev,
  libjemalloc-dev,
  libqhull-dev,
  libopenmpi-dev,
  libboost-dev,
  python3-all-dev,
  libeckit-dev (>= 1.20.0),
  libfckit-dev (>= 0.9.2-2),
  libfckit-utils,
  libcgal-dev,
  texlive-latex-base,
  texlive-latex-recommended,
  doxygen,
  doxygen-latex,
  libectrans-dev
Standards-Version: 4.6.2
Homepage: https://github.com/ecmwf/atlas
Vcs-Browser: https://salsa.debian.org:/science-team/atlas-ecmwf.git
Vcs-Git: https://salsa.debian.org:/science-team/atlas-ecmwf.git -b debian/latest

Package: libatlas-ecmwf-0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Numerical weather prediction and climate modelling library
 Atlas is an ECMWF library for parallel data-structures supporting 
 unstructured grids and function spaces, with the aim to investigate
 alternative more scalable dynamical core options for Earth System models,
 and to support modern interpolation and product generation software.
 .
 Atlas is predominantly C++ code, with main features available to Fortran codes
 through a F2003 interface. 
 ECMWF is the European Centre for Medium-Range Weather Forecasts.


Package: libatlas-ecmwf-utils
Architecture: any
Multi-Arch: foreign
Depends:  ${shlibs:Depends}, ${misc:Depends}, libatlas-ecmwf-0 (= ${binary:Version}) 
Description: Numerical weather prediction and climate modelling library - utilities
 Atlas is an ECMWF library for parallel data-structures supporting 
 unstructured grids and function spaces, with the aim to investigate
 alternative more scalable dynamical core options for Earth System models,
 and to support modern interpolation and product generation software.
 .
 Atlas is predominantly C++ code, with main features available to Fortran codes
 through a F2003 interface. 
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libatlas-ecmwf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: cmake, 
 pkg-config,
 ${fortran:Recommends}
Depends:  ${misc:Depends},
 ${fortran:Depends},
 libatlas-ecmwf-0 (= ${binary:Version}),
 libatlas-ecmwf-utils (= ${binary:Version}),
 libeckit-dev,
 libcgal-dev,
 libeigen3-dev, 
 libjemalloc-dev,
 libfckit-dev
Description: Numerical weather prediction and climate modelling library - dev files
 Atlas is an ECMWF library for parallel data-structures supporting 
 unstructured grids and function spaces, with the aim to investigate
 alternative more scalable dynamical core options for Earth System models,
 and to support modern interpolation and product generation software.
 .
 Atlas is predominantly C++ code, with main features available to Fortran codes
 through a F2003 interface. 
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
INSTDIR:=$(CURDIR)/debian/tmp
CMAKE_DIR:=$(INSTDIR)/$(LIBDIR)/cmake
FMODDIR:=$(call get_fmoddir,$(FC_DEFAULT))


DEB_CFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/debian/build/src
DEB_CXXFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/debian/build/src
DEB_FFLAGS_MAINT_APPEND= -I$(FMODDIR)

# Strange bug with omp.h headers and clang-tidy on some archs
ARCH_CLANG_TIDY_OFF:= s390x mipsel
ENABLE_CLANG_TIDY:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_CLANG_TIDY_OFF)),Off,On)

# Override in 0.27.0 build - causes failures on mixed g++/clang environments
ENABLE_CLANG_TIDY:= Off

# OMP Doesn't appear to work on these archs
ARCH_NO_OMP:= riscv64 sparc64
ENABLE_OMP:=  $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NO_OMP)),Off,On)

BUILD_FLAGS = \
	-DENABLE_DOCS=On \
	-DENABLE_CXX17=On \
	-DENABLE_CLANG_TIDY=$(ENABLE_CLANG_TIDY) \
	-DENABLE_GRIDTOOLS_STORAGE=Off  \
	-DENABLE_ACC=Off \
	-DENABLE_TESSELATION=On \
	-DENABLE_ECTRANS=On \
	-DENABLE_OMP=$(ENABLE_OMP) \
	-DENABLE_FORTRAN=On \
	-Datlas_FULL_INSTALL_CMAKE_DIR=$(LIBDIR)/cmake/atlas_ecmwf \
	-DENABLE_INIT_SNAN=On \
	-DENABLE_PROJ=On

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	dh $@ --buildsystem=ecbuild --builddir=debian/build --with fortran_mod

override_dh_auto_configure:
	dh_auto_configure -- ${BUILD_FLAGS} 

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	#LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test 
	echo "Ignore tests this build"
endif

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(INSTDIR)/$(LIBDIR)/pkgconfig
	chrpath -d $(INSTDIR)/usr/bin/*
	chrpath -d $(INSTDIR)/$(LIBDIR)/*.so*
	# rename 
	mv $(CMAKE_DIR)/atlas $(CMAKE_DIR)/atlas_ecmwf
	#for d in atlas-config.cmake  atlas-config-version.cmake  atlas-import.cmake  atlas-targets.cmake  atlas-targets-release.cmake ; do \
	#	n=`echo $$d | sed -e 's/atlas/atlas_ecmwf/' ` ; \
	#	mv $(CMAKE_DIR)/atlas_ecmwf/$$d $(CMAKE_DIR)/atlas_ecmwf/$$n ; done
	# Fix broken paths
	sed -i -e 's%$${CURDIR}%/build/atlas-ecmwf%g' \
	       -e 's%/cmake/atlas"%/cmake/atlas_ecmwf"%g' \
	       -e 's%atlas-%atlas_ecmwf-%g'               $(CMAKE_DIR)/atlas_ecmwf/atlas-config.cmake
	sed -i -e 's%/cmake/atlas"%/cmake/atlas_ecmwf"%g' \
	       -e 's%$${CURDIR}%/build/atlas-ecmwf%g'     \
	       -e 's%atlas-targets%atlas_ecmwf-targets%g' \
	       -e 's%include/atlas%include/${DEB_HOST_MULTIARCH}/atlas%g'  $(CMAKE_DIR)/atlas_ecmwf/atlas-targets.cmake

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com/ecmwf/atlas/tags .*/v?(\d\d?\d?\..+).tar\.gz
